config/routes.rb
Spree::Core::Engine.routes.draw do
  # Override for Production state
  namespace :admin, path: Spree.admin_path do
    resource :banner_message_settings, only: [:edit, :update] do
    end
  end
end

Spree::Core::Engine.routes.draw do
  get '/category/*id/(page/:page)/(per_page/:per_page)/(sort_by/:sort_by)', :to => 'taxons#show', :as => :categories
end

app/models/spree/app_configuration_decorator.rb
module Spree
  AppConfiguration.class_eval do
    preference :banner_message, :string, default: nil
    preference :banner_message2, :string, default: nil
  end
end

app/models/spree/calculator/shipping/custom_shipping_calculator.rb
require_dependency 'spree/shipping_calculator'

module Spree
  module Calculator::Shipping
    class CustomShippingCalculator < ShippingCalculator
      
      UPS_MAX_WEIGHT = 150  # 150 lbs

      def available?(package)
        package.weight >= UPS_MAX_WEIGHT
      end

      def self.description
        Spree.t(:custom_shipping)
      end

      def compute_package(package)
        0.00
      end
    end
  end
end

app/models/spree/calculator/shipping/free_shipping_over_amount_calculator.rb
require_dependency 'spree/shipping_calculator'

module Spree
  module Calculator::Shipping
    class FreeShippingOverAmountCalculator < ShippingCalculator
      preference :amount, :decimal, default: 0
      
      def available?(package)
        package.order.total >= preferred_amount
      end

      def self.description
        Spree.t(:free_shipping_over_amount)
      end

      def compute_package(package)
        0.00
      end
    end
  end
end

app/models/spree/calculator/shipping/free_shipping_under_amount_calculator.rb
require_dependency 'spree/shipping_calculator'

module Spree
  module Calculator::Shipping
    class FreeShippingUnderAmountCalculator < ShippingCalculator
      preference :amount, :decimal, default: 0
      preference :start_day_of_week, :string, default: ''
      preference :end_day_of_week, :string, default: ''
      preference :start_time, :string, default: ''
      preference :end_time, :string, default: ''
      
      def available?(package)
        package.order.total < preferred_amount && cover_timeframe?
      end

      def cover_timeframe?
        if preferred_start_day_of_week.blank? || preferred_end_day_of_week.blank? ||
            preferred_start_time.blank? || preferred_end_time.blank?
          return true
        end
         
        current_day_index = Date.today.wday
        start_wday = Date._strptime(preferred_start_day_of_week, '%A')[:wday]
        end_wday   = Date._strptime(preferred_end_day_of_week, '%A')[:wday]
        
        start_time = Time.parse(preferred_start_time)
        end_time   =  Time.parse(preferred_end_time)
        current_time = Time.now

        if (start_wday..end_wday).cover?(current_day_index) ||
            (start_wday..(end_wday + 7)).cover?(current_day_index)
          result = true

          if start_wday == end_wday
            result = start_time < current_time && end_time > current_time
          elsif start_wday == current_day_index
            result = start_time < current_time
          elsif end_wday == current_day_index
            result = end_time > current_time
          end

          return result
        else
          return false
        end
      end

      def self.description
        Spree.t(:free_shipping_under_amount)
      end

      def compute_package(package)
        0.00
      end
    end
  end
end

app/models/spree/calculator/shipping/local_pickup_calculator.rb
require_dependency 'spree/shipping_calculator'

module Spree
  module Calculator::Shipping
    class LocalPickupCalculator < ShippingCalculator
      
      def available?(package)
        true
      end

      def self.description
        Spree.t(:local_pickup)
      end

      def compute_package(package)
        0.00
      end
    end
  end
end

app/models/spree/shipping_method_decorator.rb
module Spree
  module ShippingMethodDecorator

    CODE_FEDEX = 'fedex'
    CODE_UPS = 'ups'
    CODE_USPS = 'usps'
    
    def build_tracking_url(tracking)
      return if tracking.blank?

      return tracking_url.gsub(/:tracking/, ERB::Util.url_encode(tracking)) if !tracking_url.blank? # :url_encode exists in 1.8.7 through 2.1.0

      carrier = deduceTrackingCode(tracking)
      case carrier
      when CODE_FEDEX
        carrier_tracking_url = 'https://www.fedex.com/apps/fedextrack/?action=track&tracknumbers=:tracking'
      when CODE_UPS
        carrier_tracking_url = 'http://wwwapps.ups.com/WebTracking/track?track=yes&trackNums=:tracking'
      when CODE_USPS
        carrier_tracking_url = 'https://tools.usps.com/go/TrackConfirmAction_input?qtc_tLabels1=:tracking'
      else
        carrier_tracking_url = ''
      end

      carrier_tracking_url.gsub(/:tracking/, ERB::Util.url_encode(tracking))
    end

    private
    
    def deduceTrackingCode(tracking_code)
      if tracking_code.scan(/^[0-9]{15}$/).any? || tracking_code.scan(/^[0-9]{12}$/).any?
        CODE_FEDEX
      elsif tracking_code.scan(/^1Z[A-Z0-9]{3}[A-Z0-9]{3}[0-9]{2}[0-9]{4}[0-9]{4}$/i).any? || tracking_code.scan(/^1Z[A-Z0-9]{16}$/i).any?
        CODE_UPS
      elsif tracking_code.scan(/^[0-9]{4}[0-9]{4}[0-9]{4}[0-9]{4}[0-9]{4}[0-9]{2}$/).any?
        CODE_USPS
      else
        ''
      end
    end

  end
end
::Spree::ShippingMethod.prepend(Spree::ShippingMethodDecorator)

app/models/spree/stock/estimator_decorator.rb
Spree::Stock::Estimator.class_eval do

  def choose_default_shipping_rate(shipping_rates)
    unless shipping_rates.empty?
      if shipping_rates.count == 1
        shipping_rates[0].selected = true
        return shipping_rates
      end

      remaining_rates = shipping_rates.reject { |rate| rate.shipping_method.calculator.class.name == "Spree::Calculator::Shipping::LocalPickupCalculator" }
      
      if remaining_rates.nil? || remaining_rates.min_by(&:cost).nil?
        remaining_rates
      else
        remaining_rates.min_by(&:cost).selected = true
      end
    end
  end
  
end

app/models/spree_common/configuration.rb
module SpreeCommon
  class Configuration < Spree::Preferences::Configuration

   # Some example preferences are shown below, for more information visit:
   # https://dev-docs.spreecommerce.org/internals/preferences

   preference :enabled, :boolean, default: true
   # preference :dark_chocolate, :boolean, default: true
   # preference :color, :string, default: 'Red'
   # preference :favorite_number, :integer
   # preference :supported_locales, :array, default: [:en]
  end
end

app/controllers/spree/admin/banner_message_settings_controller.rb
module Spree
  module Admin
    class BannerMessageSettingsController < Spree::Admin::BaseController
      
      def update
        params.each do |name, value|
          next unless Spree::Config.has_preference? name
          Spree::Config[name] = value
        end

        flash[:success] = Spree.t(:successfully_updated, resource: Spree.t(:banner_message_settings))
        redirect_to edit_admin_banner_message_settings_url
      end
      
    end
  end
end

app/controllers/spree/pages_controller.rb
module Spree
  class PagesController < Spree::StoreController

    def show
      locale = I18n.locale

      if valid_page?(locale)
        if locale.nil? || locale == :en
          render template: "spree/pages/#{params[:p]}"
        else
          render template: "spree/pages/#{params[:p]}.#{locale}"
        end
      else
        if locale.nil? || locale == :en
          render file: "public/404.html", status: :not_found, layout: false
        else
          render file: "public/404.#{locale}.html", status: :not_found, layout: false
        end
      end
    end

    private
    def valid_page?(locale)
      if locale.nil? || locale == :en
        template_exists?("spree/pages/#{params[:p]}.html.erb")
      else
        template_exists?("spree/pages/#{params[:p]}.#{locale}.html.erb")
      end
    end
  end
end

app/helpers/spree/base_helper_decorator.rb
Spree::BaseHelper.module_eval do

    def seo_url(taxon, params = nil)
      categories_path(taxon.permalink, params)
    end

    def sort_shipping_rates_local_pickup_last(shipping_rates)
      shipping_rates.sort_by {|x, y| if x.shipping_method.calculator.class.name == "Spree::Calculator::Shipping::LocalPickupCalculator" then 1 else 0 end }
    end
      
end

app/views/spree/admin/banner_message_settings/_form.html.erb
<div data-hook="admin_banner_message_form_fields">
  <div class="row">

    <div class="col-md-6" data-hook="general">
      <fieldset>
        <legend><%= Spree.t(:general) %></legend>

        <div class="form-group">
          <%= label_tag :banner_message, Spree.t(:banner_message) %>
          <%= text_field_tag :banner_message, Spree::Config[:banner_message], class: 'form-control' %>
        </div>
        
        <div class="form-group">
          <%= label_tag :banner_message2, Spree.t(:banner_message2) %>
          <%= text_field_tag :banner_message2, Spree::Config[:banner_message2], class: 'form-control' %>
        </div>

      </fieldset>
    </div>
  </div>
</div>

app/views/spree/admin/banner_message_settings/edit.html.erb
<% content_for :page_title do %>
  <%= Spree.t(:banner_message_settings) %>
<% end %>

<%= form_tag admin_banner_message_settings_path, method: :put do |f| %>
  <fieldset>
    <%= render 'form', f: f %>
    <div class="form-actions actions" data-hook="buttons"><%= button Spree.t('actions.update'), 'update' %></div>
  </fieldset>
<% end %>

app/views/spree/admin/orders/_production_state_change_form.html.erb
    <%= form_for [:admin, order], method: :post, :html => {:class => 'inline-block'}, url: set_production_admin_order_url do |f| %>
      <%= f.hidden_field :production_state, value: production_state %>
      <%= f.hidden_field 'redirect', value: request.fullpath %>
      <%= button production_state_label, '', 'submit', {disabled: disabled, class: "btn-#{production_state}", data: { disable_with: "Updating..." }} %>
    <% end %>

app/views/spree/admin/orders/_production_state_flow.html.erb
<%
  production_state_index = Spree::Order.get_production_states().find_index(@order.production_state)
  production_state_index = (production_state_index.nil? ? -1 : production_state_index)

  backorder_index = Spree::Order.get_production_states().find_index('backorder')
  processing_index = Spree::Order.get_production_states().find_index('processing')
  production_room_index = Spree::Order.get_production_states().find_index('production_room')
  fulfillment_room_index = Spree::Order.get_production_states().find_index('fulfillment_room')
  in_qc_index = Spree::Order.get_production_states().find_index('in_qc')
  in_labels_index = Spree::Order.get_production_states().find_index('in_labels')
  complete_index = Spree::Order.get_production_states().find_index('complete')

  backorder_disabled = production_state_index >= backorder_index
  processing_disbaled = production_state_index >= processing_index
  production_room_disabled = production_state_index >= production_room_index
  fulfillment_room_disabled = production_state_index >= fulfillment_room_index
  in_qc_disabled = production_state_index >= in_qc_index
  in_labels_disabled = production_state_index >= in_labels_index
  complete_disabled = production_state_index >= complete_index

  if production_state_index >= 0 && production_state_index < complete_index
%>
<div id="add-line-item" data-hook class="card mb-3">
  <div class="card-header">
    <h1 class="card-title mb-0 h5">Current Production State: <span class="badge badge-<%= @order.production_state %>"><%= Spree.t("production_states.#{@order.production_state}") %></span></h1>
  </div>
  <div class="card-body">
    Change State:
    <div class="production-form-actions" data-hook="production-state-buttons">
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'backorder', production_state_label: 'Backorder', disabled: backorder_disabled } %>
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'processing', production_state_label: 'Processing', disabled: processing_disbaled } %>
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'production_room', production_state_label: 'Production Room', disabled: production_room_disabled } %>
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'fulfillment_room', production_state_label: 'Fulfillment Room', disabled: fulfillment_room_disabled } %>
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'in_qc', production_state_label: 'In QC', disabled: in_qc_disabled } %>
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'in_labels', production_state_label: 'In Labels', disabled: in_labels_disabled } %>
      <%= render partial: 'production_state_change_form', locals: { order: @order, production_state: 'complete', production_state_label: 'Complete', disabled: complete_disabled } %>
    </div>
  </div>
</div>
<% end %>